# -*-python-*-
# $Id: Constants.py,v 1.19 2005/12/29 17:08:40 asc Exp $

__author__     = "Aaron Straup Cope"
__url__        = "http://www.aaronland.info/python/ImageWidget/"
__version__    = "1.0"
__cvsversion__ = "$Revision: 1.19 $"
__date__       = "$Date: 2005/12/29 17:08:40 $"
__copyright__  = "Copyright (c) 2004-2006 Aaron Straup Cope. GNU GPL 2"

import wx
import sys

IMAGEWIDGET_KEY_CMD    = u"\N{PLACE OF INTEREST SIGN}"
IMAGEWIDGET_KEY_OPTION = u"\N{OPTION KEY}"
IMAGEWIDGET_KEY_CTRL   = u"Ctrl+"
IMAGEWIDGET_KEY_SHIFT  = u"\N{UPWARDS WHITE ARROW}"
IMAGEWIDGET_KEY_ALT    = u"Alt+"

if sys.platform == "darwin" :
    IMAGEWIDGET_KEY_MOD = IMAGEWIDGET_KEY_CMD
    IMAGEWIDGET_KEY_ALT = IMAGEWIDGET_KEY_OPTION
else :
    IMAGEWIDGET_KEY_MOD = IMAGEWIDGET_KEY_CTRL

IMAGEWIDGET_NAMESPACE = "http://aaronland.info/python/ImageWidget#"

IMAGEWIDGET_SECONDS_DELAY  = 30
IMAGEWIDGET_SECONDS_SLEEP  = 0.01
IMAGEWIDGET_COUNTER_DELAY  = int(1/IMAGEWIDGET_SECONDS_SLEEP) * IMAGEWIDGET_SECONDS_DELAY

IMAGEWIDGET_ERR_GETCONFIG       = u"Unable to load preferences"
IMAGEWIDGET_ERR_UNDEFINEDMETHOD = u"Undefined method"
IMAGEWIDGET_ERR_FETCHIMAGE      = u"Unable to retrieve image"
IMAGEWIDGET_ERR_GETSIZE         = u"Unable to determine image dimensions"
IMAGEWIDGET_ERR_NONET           = u"No network connection"

IMAGEWIDGET_ID_APP        = wx.NewId()

IMAGEWIDGET_ID_PAUSE       = wx.NewId()
IMAGEWIDGET_ID_NEXT        = wx.NewId()
IMAGEWIDGET_ID_RESUME      = wx.NewId()
IMAGEWIDGET_ID_EXIT        = wx.NewId()
IMAGEWIDGET_ID_LOG         = wx.NewId()
IMAGEWIDGET_ID_MAXWIDTH    = wx.NewId()
IMAGEWIDGET_ID_MAXHEIGHT   = wx.NewId()
IMAGEWIDGET_ID_BROWSEROPEN = wx.NewId()
IMAGEWIDGET_ID_COPYURL     = wx.NewId()

IMAGEWIDGET_ID_INFO  = wx.NewId()
IMAGEWIDGET_ID_ABOUT = wx.NewId()

IMAGEWIDGET_APP_NAME        = u"Image Widget"
IMAGEWIDGET_VERSION_MAJOR   = u"1.0"
IMAGEWIDGET_VERSION_MINOR   = u"b6"
IMAGEWIDGET_VERSION         = IMAGEWIDGET_VERSION_MAJOR + IMAGEWIDGET_VERSION_MINOR
IMAGEWIDGET_APP_DESCRIPTION = u"Image Widget" + IMAGEWIDGET_VERSION + u"\nCopyright \N{COPYRIGHT SIGN} 2005 Aaron Straup Cope"

IMAGEWIDGET_INFO_TITLE     = u"Image Info"

IMAGEWIDGET_MENUBAR_FILE   = u"&File"
IMAGEWIDGET_MENUBAR_EDIT   = u"&Edit"
IMAGEWIDGET_MENUBAR_TOOLS  = u"&Tools" 
IMAGEWIDGET_MENUBAR_HELP   = u"&Help"

# FIX ME : spacing

IMAGEWIDGET_MENU_ABOUT     = u"&About " + IMAGEWIDGET_KEY_MOD + "A"
IMAGEWIDGET_MENU_NEXT      = u"&Next " + IMAGEWIDGET_KEY_MOD + "N"
IMAGEWIDGET_MENU_PAUSE     = u"&Pause " + IMAGEWIDGET_KEY_MOD + "P"
IMAGEWIDGET_MENU_RESUME    = u"&Resume " + IMAGEWIDGET_KEY_MOD + "R"
IMAGEWIDGET_MENU_INFO      = u"Image &Info " + IMAGEWIDGET_KEY_MOD + "I"
IMAGEWIDGET_MENU_QUIT      = u"&Quit " + IMAGEWIDGET_KEY_MOD + "Q"
IMAGEWIDGET_MENU_LOG       = u"&Log " + IMAGEWIDGET_KEY_MOD + "L"
IMAGEWIDGET_MENU_MAXWIDTH  = u"&Width " + IMAGEWIDGET_KEY_SHIFT + IMAGEWIDGET_KEY_MOD + "W"
IMAGEWIDGET_MENU_MAXHEIGHT = u"&Height " + IMAGEWIDGET_KEY_SHIFT + IMAGEWIDGET_KEY_MOD + "H"

IMAGEWIDGET_MENU_BROWSEROPEN = u"&Open in browser " + IMAGEWIDGET_KEY_MOD + "O"
IMAGEWIDGET_MENU_COPYURL     = u"&Copy URL to clipboard " + IMAGEWIDGET_KEY_MOD + "C"

IMAGEWIDGET_DESCRIBE_PAUSE   = u"Pause showing new images"
IMAGEWIDGET_DESCRIBE_NEXT    = u"Show a new image"
IMAGEWIDGET_DESCRIBE_RESUME  = u"Continue showing new images"
IMAGEWIDGET_DESCRIBE_INFO    = u"Info"
IMAGEWIDGET_DESCRIBE_ABOUT   = u"More information about this program"
IMAGEWIDGET_DESCRIBE_QUIT    = u"Quit the program"
IMAGEWIDGET_DESCRIBE_LOG     = u"Log program events"
IMAGEWIDGET_DESCRIBE_MAXHEIGHT = u"Set maximum height for an image."
IMAGEWIDGET_DESCRIBE_MAXWIDTH  = u"Set maximum width for an image."
IMAGEWIDGET_DESCRIBE_BROWSEROPEN = u"Open in browser"
IMAGEWIDGET_DESCRIBE_COPYURL = u"Copy URL to clipboard."

IMAGEWIDGET_MSG_PAUSED       = u"paused, press Ctrl-R to resume"
IMAGEWIDGET_MSG_POLLING      = u"asking for a new image"
IMAGEWIDGET_MSG_PROCESSING   = u""
IMAGEWIDGET_MSG_LOG          = u"Logging enabled";
IMAGEWIDGET_MSG_NOLOG        = u"Logging disabled";

IMAGEWIDGET_ERR_POLLING    = u"failed to get image from server"
IMAGEWIDGET_ERR_STRINGIFY  = u"failed to read image from server"
IMAGEWIDGET_ERR_STREAMIFY  = u"failed to munge image"
IMAGEWIDGET_ERR_DISPLAY    = u"failed to set image"
IMAGEWIDGET_ERR_IMAGEINFO  = u"no image data"
IMAGEWIDGET_ERR_LOADCONFIG   = u"Failed to load preferences"
IMAGEWIDGET_ERR_PARSECONFIG  = u"Failed to parse preferences"
IMAGEWIDGET_ERR_SAVECONFIG   = u"Failed to save preferences"
IMAGEWIDGET_ERR_BACKUPCONFIG = u"Failed to backup preferences"
IMAGEWIDGET_ERR_STOPCONFIG   = u"Failed to locate preference"
IMAGEWIDGET_ERR_READCONFIG   = u"Failed to read preference"
IMAGEWIDGET_ERR_STOPPREF     = u"Failed to locate preference"
IMAGEWIDGET_ERR_READPREF     = u"Failed to read preference"
IMAGEWIDGET_ERR_CURRENTPHOTO = u"No photo ID defined"
IMAGEWIDGET_ERR_BROWSEROPEN  = u"Failed to open URL in browser"
IMAGEWIDGET_ERR_CLIPBOARDOPEN = u"Failed to open the clipboard"

IMAGEWIDGET_CFG_ERROR_TITLE = u"Error"

IMAGEWIDGET_CFG_PREFERENCES = u"preferences"
IMAGEWIDGET_CFG_PREFS     = IMAGEWIDGET_CFG_PREFERENCES
IMAGEWIDGET_CFG_LOGIN     = u"login"
IMAGEWIDGET_CFG_FILTER    = u"filter"
IMAGEWIDGET_CFG_MAXWIDTH  = u"max-width"
IMAGEWIDGET_CFG_MAXHEIGHT = u"max-height"
IMAGEWIDGET_CFG_LOGGING   = u"logging"
IMAGEWIDGET_CFG_POSX      = u"pos-x"
IMAGEWIDGET_CFG_POSY      = u"pos-y"

IMAGEWIDGET_CFG_MAXHEIGHT_ERROR  = u"Failed to set %s as maximum height"
IMAGEWIDGET_CFG_MAXHEIGHT_PROMPT = u"Set the maximum height, in pixels, to display images on screen \N{HORIZONTAL BAR} if zero, or blank, then the image's height will not be affected."
IMAGEWIDGET_CFG_MAXHEIGHT_TITLE  = u"Maximum image height"

IMAGEWIDGET_CFG_MAXWIDTH_ERROR  = u"Failed to set %s as maximum width"
IMAGEWIDGET_CFG_MAXWIDTH_PROMPT = u"Set the maximum width, in pixels, to display images on screen \N{HORIZONTAL BAR} if zero, or blank, then the image's width will not be affected."
IMAGEWIDGET_CFG_MAXWIDTH_TITLE  = u"Maximum image width"

# These need better names...

IMAGEWIDGET_STATUSTEXT = 0.8
IMAGEWIDGET_DIM_BORDER = 4

IMAGEWIDGET_DEFAULT_POS = wx.DefaultPosition
IMAGEWIDGET_DEFAULT_SZX = 300
IMAGEWIDGET_DEFAULT_SZY = 300
IMAGEWIDGET_DEFAULT_POSX = -1
IMAGEWIDGET_DEFAULT_POSY = -1
IMAGEWIDGET_DEFAULT_LOGGING = 0

IMAGEWIDGET_DEFAULT_SZ  = wx.Size(300,300)

IMAGEWIDGET_DIALOG_ABOUT = u"Image Widget " + IMAGEWIDGET_VERSION + u"\nCopyright \N{COPYRIGHT SIGN} 2005-2006 Aaron Straup Cope."

IMAGEWIDGET_LOGIN_ID_USERNAME = wx.NewId()
IMAGEWIDGET_LOGIN_ID_PASSWORD = wx.NewId()
IMAGEWIDGET_LOGIN_ID_SAVEAUTH = wx.NewId()
IMAGEWIDGET_LOGIN_ID_OK       = wx.ID_OK
IMAGEWIDGET_LOGIN_ID_CANCEL   = wx.ID_CANCEL

IMAGEWIDGET_LOGIN_LABEL_USERNAME = u"Username"
IMAGEWIDGET_LOGIN_LABEL_PASSWORD = u"Password"

IMAGEWIDGET_LOGIN_LABEL_SAVEAUTH = u"Save login"
IMAGEWIDGET_LOGIN_LABEL_OK       = u"OK"
IMAGEWIDGET_LOGIN_LABEL_CANCEL   = u"Cancel"
