# $Id: Logger.py,v 1.4 2005/03/27 17:06:43 asc Exp $

__author__     = "Aaron Straup Cope"
__url__        = "http://www.aaronland.info/python/ImageWidget/"
__version__    = "1.0"
__cvsversion__ = "$Revision: 1.4 $"
__date__       = "$Date: 2005/03/27 17:06:43 $"
__copyright__  = "Copyright (c) 2004-2006 Aaron Straup Cope. GNU GPL 2"

import logging
import logging.handlers
import os

from ImageWidget.Constants import IMAGEWIDGET_MSG_LOG,IMAGEWIDGET_MSG_NOLOG

class ImageWidgetLogger :
      
    def __init__ (self,log,name,min_level=logging.INFO) :

        self.Logger = logging.getLogger(name)
            
        formatter = logging.Formatter('%(asctime)s %(levelname)s %(message)s')
        
	# As in : -rw-------
	old_umask = os.umask(0077)

        handler   = logging.handlers.RotatingFileHandler(log,
                                                         "a",
                                                         (1024 * 1024),
                                                         3)

	os.umask(old_umask)

        handler.setFormatter(formatter)
        
        self.Logger.addHandler(handler)
        self.Logger.setLevel(min_level)
        
        self.dispatch("info",IMAGEWIDGET_MSG_LOG)
                
    def dispatch (self,event,msg) :
        logger = getattr(self.Logger, event)
        return logger(msg)
